package anywheresoftware.b4a.jalle007.wificonnect;

import java.util.List;

import android.net.wifi.WifiConfiguration;
import android.net.wifi.WifiManager;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;

@Author("jalle007")
@Version(1.1f)
@ShortName("WiFiConnect")
public class WiFiConnect
{
	// 1.0 initial release
	// 1.1 added test for no networks found and added IsEnabled 
	private final static double version = 1.1;	
	
	/**
	 *Returns the version number of the library.
	 */
	public double getVersion()
	{
		return version;
	}
	
	
	public int WIFI_OPEN = 0;
	public int WIFI_WEP = 1;
	public int WIFI_WPA = 2;

	public void connectToSSID(BA ba, int wifi_security, String networkSSID, String networkPass) throws Exception
	{

		WifiConfiguration conf = new WifiConfiguration();
		conf.SSID = "\"" + networkSSID + "\""; // Please note the quotes. String should contain ssid in quotes

		//tip = Integer.parseInt(txtTip.toString());

		switch (wifi_security) {
		case 0: // OPEN
			conf.allowedKeyManagement.set(WifiConfiguration.KeyMgmt.NONE);

		case 1: // WEP
			conf.wepKeys[0] = "\"" + networkPass + "\"";
			conf.wepTxKeyIndex = 0;
			conf.allowedKeyManagement.set(WifiConfiguration.KeyMgmt.NONE);
			conf.allowedGroupCiphers.set(WifiConfiguration.GroupCipher.WEP40);
			break;

		case 2: // WPA
			conf.preSharedKey = "\"" + networkPass + "\"";

		default:
			break;
		}

		WifiManager wifiManager = (WifiManager) ba.context.getSystemService(ba.context.WIFI_SERVICE);
		wifiManager.addNetwork(conf);

		// CONNECT
		List<WifiConfiguration> list = wifiManager.getConfiguredNetworks();
		if (list == null)
		{
			throw new Exception("No configured networks found!");
		}
		for (WifiConfiguration i : list)
		{
			if (i.SSID != null && i.SSID.equals("\"" + networkSSID + "\""))
			{
				wifiManager.disconnect();
				wifiManager.enableNetwork(i.networkId, true);
				wifiManager.reconnect();

				break;
			}
		}
	}
	
	
	public boolean IsWiFiEnabled(BA ba)
	{		
		WifiManager wifiManager = (WifiManager) ba.context.getSystemService(ba.context.WIFI_SERVICE);
		return wifiManager.isWifiEnabled();
	}
	

}
